Lab_PPW_2017/urls.py
from django.conf.urls import url,include
from django.views.generic import RedirectView
import lab_1.urls as lab_1
import lab_2.urls as lab_2
import lab_3.urls as lab_3
import lab_4.urls as lab_4
import lab_5.urls as lab_5
import lab_6.urls as lab_6
import lab_7.urls as lab_7
import lab_8.urls as lab_8
import lab_9.urls as lab_9
import lab_10.urls as lab_10
import lab_2_addon.urls as lab_2_addon

urlpatterns = [
    url(r'^lab-1/', include(lab_1,namespace='lab-1')),
    url(r'^lab-2/', include(lab_2,namespace='lab-2')),
    url(r'^lab-3/', include(lab_3,namespace='lab-3')),
    url(r'^lab-4/', include(lab_4,namespace='lab-4')),
    url(r'^lab-5/', include(lab_5,namespace='lab-5')),
    url(r'^lab-6/', include(lab_6,namespace='lab-6')),
    url(r'^lab-7/', include(lab_7,namespace='lab-7')),
    url(r'^lab-8/', include(lab_8,namespace='lab-8')),
    url(r'^lab-9/', include(lab_9,namespace='lab-9')),
    url(r'^lab-10/', include(lab_10,namespace='lab-10')),
    url(r'^lab-2-addon/', include(lab_2_addon,namespace='lab-2-addon')),
    url(r'^$', RedirectView.as_view(url='lab-10/', permanent=True)),
]

lab_1/urls.py
from django.conf.urls import url
from .views import index
#url for app
urlpatterns = [
    url(r'^$', index, name='index'),
]

lab_10/urls.py
from django.conf.urls import url
from .views import *

from lab_9.custom_auth import auth_login, auth_logout

urlpatterns = [
    # custom auth
    url(r'^custom_auth/login/$', auth_login, name='auth_login'),
    url(r'^custom_auth/logout/$', auth_logout, name='auth_logout'),

    # index dan dashboard
    url(r'^$', index, name='index'),
    url(r'^dashboard/$', dashboard, name='dashboard'),

    #movie
    url(r'^movie/list/$', movie_list, name='movie_list'),
    url(r'^movie/detail/(?P<id>.*)/$', movie_detail, name='movie_detail'),

    # Session dan Model (Watch Later)
    url(r'^movie/watch_later/add/(?P<id>.*)/$', add_watch_later, name='add_watch_later'),
    url(r'^movie/watch_later/$', list_watch_later, name='list_watch_later'),

    #API
    url(r'^api/movie/(?P<judul>.*)/(?P<tahun>.*)/$', api_search_movie, name='api_search_movie'),
]

lab_10/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models

class Pengguna(models.Model):
    kode_identitas = models.CharField('Kode Identitas', max_length=20, primary_key=True, )
    nama = models.CharField('Nama', max_length=200)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

class MovieKu(models.Model):
    pengguna = models.ForeignKey(Pengguna)
    kode_movie = models.CharField("Kode Movie", max_length=50)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

lab_10/views.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import json

from django.contrib import messages
from django.http import HttpResponseRedirect, HttpResponse
from django.shortcuts import render
from django.urls import reverse

from .omdb_api import get_detail_movie, search_movie
from .utils import *
response = {}

# Create your views here.

### USER
def index(request):
    # print ("#==> masuk index")
    if 'user_login' in request.session:
        response['login'] = True
        return HttpResponseRedirect(reverse('lab-10:dashboard'))
    else:
        response['login'] = False
        response['author'] = get_data_user(request, 'user_login')
        html = 'lab_10/login.html'
        return render(request, html, response)

def dashboard(request):
    print ("#==> dashboard")

    if not 'user_login' in request.session.keys():
        return HttpResponseRedirect(reverse('lab-10:index'))
    else:
        set_data_for_session(request)
        kode_identitas = get_data_user(request, 'kode_identitas')
        try:
            pengguna = Pengguna.objects.get(kode_identitas = kode_identitas)
        except Exception as e:
            pengguna = create_new_user(request)

        movies_id = get_my_movies_from_session(request)
        save_movies_to_database(pengguna, movies_id)

        html = 'lab_10/dashboard.html'
        return render(request, html, response)

### MOVIE : LIST and DETAIL
def movie_list(request):
    if 'user_login' in request.session.keys():
        response['login'] = True
    else:
        response['login'] = False
    print(response['login'])
    judul, tahun = get_parameter_request(request)
    urlDataTables = "/lab-10/api/movie/" + judul + "/" + tahun + "/"
    jsonUrlDT = json.dumps(urlDataTables)
    response['jsonUrlDT'] = jsonUrlDT
    response['judul'] = judul
    response['tahun'] = tahun

    get_data_session(request)

    html = 'lab_10/movie/list.html'
    return render(request, html, response)

def movie_detail(request, id):
    print ("MOVIE DETAIL = ", id)
    response['id'] = id
    if get_data_user(request, 'user_login'):
        response['login'] = True
        is_added = check_movie_in_database(request, id)
    else:
        response['login'] = False
        is_added = check_movie_in_session(request, id)

    response['added'] = is_added
    response['movie'] = get_detail_movie(id)
    html = 'lab_10/movie/detail.html'
    return render(request, html, response)

### WATCH LATER : ADD and LIST
def add_watch_later(request, id):
    print ("ADD WL => ", id)
    msg = "Berhasil tambah movie ke Watch Later"
    if get_data_user(request, 'user_login'):
        print ("TO DB")
        is_in_db = check_movie_in_database(request, id)
        if not is_in_db:
            add_item_to_database(request, id)
        else:
            msg = "Movie already exist on DATABASE! Hacking detected!"
    else:
        print ("TO SESSION")
        is_in_ssn = check_movie_in_session(request, id)
        if not is_in_ssn:
            add_item_to_session(request, id)
        else:
            msg = "Movie already exist on SESSION! Hacking detected!"

    messages.success(request, msg)
    return HttpResponseRedirect(reverse('lab-10:movie_detail', args=(id,)))

def list_watch_later(request):
    #  Implement this function by yourself
    get_data_session(request)
    moviesku = []
    if get_data_user(request, 'user_login'):
        response['login'] = True
        moviesku = get_my_movies_from_database(request)
    else:
        response['login'] = False
        moviesku = get_my_movies_from_session(request)

    watch_later_movies = get_list_movie_from_api(moviesku)

    response['watch_later_movies'] = watch_later_movies
    html = 'lab_10/movie/watch_later.html'
    return render(request, html, response)

### SESSION : GET and SET
def get_data_session(request):
    if get_data_user(request, 'user_login'):
        response['author'] = get_data_user(request, 'user_login')

def set_data_for_session(request):
    response['author'] = get_data_user(request, 'user_login')
    response['kode_identitas'] = request.session['kode_identitas']
    response['role'] = request.session['role']

### API : SEARCH movie
def api_search_movie(request, judul, tahun):
    print ("API SEARCH MOVIE")
    if judul == "-" and tahun == "-":
        items = []
    else:
        search_results = search_movie(judul, tahun)
        items = search_results

    dataJson = json.dumps({"dataku":items})
    mimetype = 'application/json'
    return HttpResponse(dataJson, mimetype)

lab_10/templates/lab_10/dashboard.html
{% extends "lab_10/layout/base.html" %}

{% block header %}
<div class="navbar navbar-default navbar-static-top" role="navigation">
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a target="_blank" href="{% url 'lab-10:index' %}" class="navbar-brand">Cansky</a>
        </div>
        <div class="collapse navbar-collapse">
            <ul class="nav navbar-nav navbar-right">
                <li class="dropdown">
                    <a href="#" class="dropdown-toggle" data-toggle="dropdown">
                        <span class="glyphicon glyphicon-user"></span> 
                        <strong>{{author}}</strong>
                        <span class="glyphicon glyphicon-chevron-down"></span>
                    </a>
                    <ul class="dropdown-menu">
                        <li>
                            <div class="navbar-login">
                                <div class="row">
                                    <div class="col-lg-4">
                                        <p class="text-center">
                                            <span class="glyphicon glyphicon-user icon-size"></span>
                                        </p>
                                    </div>
                                    <div class="col-lg-8">
                                        <p class="text-left"><strong>{{author}}</strong></p>
                                        <p class="text-left small">{{kode_identitas}}</p>
                                    </div>
                                </div>
                            </div>
                        </li>
                        <li class="divider"></li>
                        <li>
                            <div class="navbar-login navbar-login-session">
                                <div class="row">
                                    <div class="col-lg-12">
                                        <p>
                                            <a href="{% url 'lab-9:auth_logout' %}" class="btn btn-danger btn-block" onclick="return confirm('Keluar?')">
                                                Logout </a>
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </li>
                    </ul>
                </li>
            </ul>
        </div>
    </div>
</div>
{% endblock%}

{% block content %}
<!-- Content Here -->
<section id="data-dashboard">
    <div class="panel panel-default">
        <div class="panel-heading">
            <h2> Dashboard </h2>
        </div>
        <div class="panel-body">
            <p> Username : {{ author }} </p>
            <p> NPM : {{kode_identitas}} </p>
            <p> Role : {{ role }} </p>
            <p>
                <a href="{% url 'lab-10:movie_list' %}" class="btn btn-primary"> Daftar Movie </a> |
                <a href="{% url 'lab-10:list_watch_later' %}" class="btn btn-warning"> Daftar Watch Later </a>
            </p>
        </div>
        <div class="panel-footer">
            <a href="{% url 'lab-10:auth_logout' %}" class="btn btn-danger" onclick="return confirm('Keluar?')">
                Logout </a>
        </div>
    </div>
</section>
<hr>

{% endblock %}

lab_10/templates/lab_10/login.html
{% extends "lab_9/layout/base.html" %}


{% block header %}
<div class="navbar navbar-default navbar-fixed-top" role="navigation">
    <div class="container">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a target="_blank" href="{% url 'lab-10:index' %}" class="navbar-brand">Cansky</a>
        </div>
    </div>
</div>
{% endblock%}


{% block content %}
<div class="row">
    <div class="col-md-6 col-md-offset-3">
        <div class="rata-tengah">
            <div class="judul">
                <h1> Halaman Login </h1>
                <p class="text-info"> Gunakan <b> akun SSO </b> untuk login </p>
            </div>
            <form action="{% url 'lab-9:auth_login' %}" method="POST">
                {% csrf_token %}
                <p>
                    <label for="username"> Your username </label>
                    <input type="text" id="username" name="username" required>
                </p>
                <p>
                    <label for="password"> Your password </label>
                    <input type="password" id="password" name="password" required>
                </p>
                <input type="submit" class="btn btn-primary">
            </form>
        </div>
    </div>
</div>
{% endblock %}